import * as React from 'react';
import './style.scss';
interface IBtn {
    name: string;
    className?: string;
    type?: 'primary' | 'danger' | 'default';
    value?: string | number | boolean;
    onClick?: () => void;
    [otherProps: string]: any;
}
interface IAlertParams {
    title?: string | React.ReactElement<any>;
    desc?: string | React.ReactElement<any>;
    className?: string;
    btns?: IBtn[];
    btnDirection?: 'row' | 'column';
}
declare type IAsyncAlert = (params: IAlertParams | string) => Promise<string | number | boolean | undefined>;
declare type IAlert = ((params: IAlertParams | string, callback?: (value?: string | number | boolean) => void) => [() => void, void]) & {
    async: IAsyncAlert;
};
declare const Alert: IAlert;
export default Alert;
