var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import cn from 'classnames';
import * as React from 'react';
import { Link } from 'react-router-dom';
import './style.scss';
var CellRow = function (props) {
    var value = props.value, arrow = props.arrow, onClick = props.onClick, href = props.href, to = props.to, activable = props.activable, className = props.className, children = props.children, title = props.title, indentLine = props.indentLine, endIndentLine = props.endIndentLine, otherProps = __rest(props, ["value", "arrow", "onClick", "href", "to", "activable", "className", "children", "title", "indentLine", "endIndentLine"]);
    var composeClassName = cn('x-cell__row', className, {
        'x-cell__row--activable': onClick || to || href || activable,
        'x-cell__row--arrow': arrow,
        'x-cell__row--indent-line': indentLine,
        'x-cell__row--end-indent-line': endIndentLine,
    });
    var content = function () { return (React.createElement(React.Fragment, null,
        title && React.createElement("label", null, title),
        children)); };
    if (onClick) {
        var onClickHandle = function () { return onClick(value); };
        return (React.createElement("div", __assign({}, otherProps, { className: composeClassName, onClick: onClickHandle }), content()));
    }
    if (to) {
        return (React.createElement(Link, __assign({}, otherProps, { className: composeClassName, to: to }), content()));
    }
    if (href) {
        return (React.createElement("a", __assign({}, otherProps, { className: composeClassName, href: href }), content()));
    }
    return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }), content()));
};
var CellTitle = function (props) {
    var text = props.text, className = props.className, otherProps = __rest(props, ["text", "className"]);
    var composeClassName = cn('x-cell__title', className);
    return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }),
        React.createElement("h2", null, props.text)));
};
var Cell = function (props) {
    var arrow = props.arrow, indentLine = props.indentLine, endIndentLine = props.endIndentLine, className = props.className, children = props.children, onClick = props.onClick, otherProps = __rest(props, ["arrow", "indentLine", "endIndentLine", "className", "children", "onClick"]);
    var composeClassName = cn('x-cell', className);
    var composeChildren = [];
    if (Array.isArray(children)) {
        composeChildren.push.apply(composeChildren, children);
    }
    else {
        composeChildren.push(children);
    }
    return (React.createElement("section", __assign({}, otherProps, { className: composeClassName }), composeChildren.map(function (children, index) {
        if (children && children.type === CellRow) {
            return React.cloneElement(children, {
                key: index,
                arrow: children.props.arrow === false ? false : arrow || children.props.arrow,
                onClick: children.props.href || children.props.to ? void 0 : onClick || children.props.onClick,
                indentLine: indentLine,
                endIndentLine: endIndentLine,
            });
        }
        return children;
    })));
};
Cell.Row = CellRow;
Cell.Title = CellTitle;
export default Cell;
