export interface Times {
    HHList: string[];
    MMList: {
        [HH: string]: string[];
    };
}
export interface TimeData {
    day: Date;
    times?: string[] | string[][];
}
interface TimeState {
    times: Times;
    HHList: string[];
    MMList: string[];
    currentDayIndex: number;
    currentDayValue: Date;
    currentHHIndex: number;
    currentHHValue: string;
    currentMMIndex: number;
    currentMMValue: string;
}
declare type DateFormat = [string, string, string];
declare class Model {
    HHList: string[];
    MMList: string[];
    constructor();
    getDayList: (data: TimeData[], format: DateFormat) => string[];
    getStateByTime: (time: Date, data: TimeData[]) => TimeState;
    transTimeList: (times: string[]) => Times;
    getTimeRange: (start: string, end: string) => string[];
    isZeroTime(date: Date): boolean;
    getTimeList: (day: TimeData) => string[];
}
declare const _default: Model;
export default _default;
