import * as React from 'react';
import { createPortal, render, unmountComponentAtNode } from 'react-dom';
import './style.scss';
var timer = 0;
var div;
var close = function () {
    if (div) {
        div.classList.remove('x-toast--show');
        div.classList.add('x-toast--hide');
        clearTimeout(timer);
        setTimeout(remove, 200);
    }
};
var remove = function () {
    if (div && div.parentNode) {
        unmountComponentAtNode(div);
        div.parentNode.removeChild(div);
        div = null;
    }
};
var Toast = function (text, duration) {
    if (duration === void 0) { duration = 2000; }
    remove();
    div = document.createElement('div');
    div.classList.add('x-toast', 'x-toast--show');
    div.id = 'j-x-toast';
    document.body.appendChild(div);
    render(createPortal(React.createElement("div", { className: "x-toast__inner" },
        React.createElement("p", null, text)), div), div);
    clearTimeout(timer);
    timer = setTimeout(function () {
        close();
    }, Math.max(duration, 500));
    return [close, void 0];
};
Toast.hide = close;
export default Toast;
